package furyPackage;

import jge2d.Ponto;

/**
 * <p><b>Title:</b> Fury of the Tiny
 * <p><b>Description:</b> Grgula
 * <p><b>Copyright:</b> Copyright (c) 2005
 * <p><b>Company:</b> 4thFloor Corporation
 * @author Srgio Lopes<br>Ruben Pedro
 * @version 5.0
 */
public class Gargula extends FixoResistente {
    /**
     * Tiro da grgula
     */
    private TiroGargula tiro;

    /**
     * Cadncia do tiro da grgula
     */
    private int cadencia;

    /**
     * Guarda o tempo do ltimo tiro disparado
     */
    private long tempoLastFire;

    /**
     * @param capacidadeResistencia - Define a capacidade de resistncia de uma Grgula
     * @param cadencia - Frequncia com que o tiro da grgula  disparado
     * @param tiro - Tiro da grgula
     */
    public Gargula(String nome, Ponto posicao, Nivel nivel, int capacidadeResistencia, int cadencia, TiroGargula tiro) {
        super(nome, posicao, nivel, capacidadeResistencia);
        this.cadencia = cadencia;
        this.tiro = tiro;
    }

    /**
     * Lana um tiro de grgula
     */
    public void disparar(long tempo) {
        new TiroGargula(tiro).lancar(tempo);
   }

    /**
     * Itera a grgula disparando tiros consoante a sua cadncia
     */
    public void iterar(long tempo) {
        if (tempo - tempoLastFire >= cadencia) {
            tempoLastFire = tempo;
            disparar(tempo);
        }
    }



/////////////////////////// Getters & Setters //////////////////////////////////

    public int getCadencia() {
        return cadencia;
    }

    public TiroGargula getTiro() {
        return tiro;
    }
}
