/* Generated by Together */

package furyPackage.estados;

import furyPackage.Tiny;

/**
 * Habilidade que o Tiny pode possuir
 */
public abstract class Habilidade extends DetentorDoTiny {

    /**
     * Permite saber se a habilidade se encontra ou no disponvel no nvel, para que o Tiny a possa usar
     */
    private boolean disponivel;
    private boolean disponibilidadeInicial;
    public static final int SELECCAO = 0;
    public static final int FOGO = 1;
    public static final int MARTELO = 2;
    public static final int CORDA = 3;

    public static final String NOME_ESQUERDA = "Esquerda";
    public static final String NOME_DIREITA = "Direita";
    public static final String NOME_FRENTE = "Frente";
    public static final String NOME_HOP = "Fly";
    public static final String NOME_FLY_DIREITA = "FlyDireita";
    public static final String NOME_FLY_ESQUERDA = "FlyEsquerda";
    public static final String NOME_SELECT = "Seleccionar";


    public Habilidade() {
    }

    /**
     * @param heroi - Tiny
     * @param disponivel - Disponibilidade da habilidade.
     */
    public Habilidade(Tiny heroi, boolean disponivel) {
        super(heroi);
        this.disponivel = disponibilidadeInicial = disponivel;
    }

    public abstract void disparar(long tempo);

    public abstract void dispararEsquerda(long tempo);

    public abstract void dispararDireita(long tempo);

    public abstract void dispararParado(long tempo);

    public boolean isDisponivel() {
        return disponivel;
    }

    public void alterarDisponibilidade() {
        disponivel = !disponivel;
    }

    public void reiniciarDisponibilidade() {
        disponivel = disponibilidadeInicial;
    }

    public abstract String getAnimacaoEsquerda();

    public abstract String getAnimacaoDireita();

    public abstract String getAnimacaoFrente();

    public abstract String getAnimacaoSalto();

    public abstract String getAnimacaoSaltoEsquerdo();

    public abstract String getAnimacaoSaltoDireito();

    public abstract String getAnimacaoSeleccao();

    public abstract String toString();

}
